Macro Perpendicular To Wire

From FreeCAD Documentation
Jump to navigation Jump to search
This page is a translated version of the page Macro Perpendicular To Wire and the translation is 100% complete.
Other languages:
English • ‎français • ‎italiano

Macro Perpendicular To Wire.png Macro Perpendicular To Wire

Description
Cette macro place l'objet sélectionné perpendiculairement au fil sélectionné.

Version macro : 00.02
Date dernière modification : 2019-04-06
Version FreeCAD : All
Téléchargement : ToolBar Icon
Auteur
Mario52
Téléchargement
ToolBar Icon
Liens
Version Macro
00.02
Dernière modification
2019-04-06
Version(s) FreeCAD
All
Raccourci clavier
None
Voir aussi
None


Description

Cette macro place l'objet sélectionné perpendiculairement au fil sélectionné.

Utilisation

  1.  : sélectionnez le chemin (Le chemin peut être un objet ou sous objet)
  2.  : sélectionnez l'objet qui doit être aligné
  3.  : lancez macro

Script

L'icône pour votre barre d'outils Macro Perpendicular To Wire.png

Macro Perpendicular To Wire.FCMacro

# -*- coding: utf-8 -*-
__title__   = "Macro Perpendicular To Wire"
__author__  = "Mario52"
__url__     = "https://www.freecadweb.org/wiki/index.php?title=Macro_Perpendicular_To_Wire"
__version__ = "00.02"
__date__ = "06/04/2019"

import Draft, Part

try:
    sel = FreeCADGui.Selection.getSelection()                               # Select an object
    
    lineSelected = FreeCADGui.Selection.getSelectionEx()[0].SubObjects[0]   # first object the Path object or SubObjects
    myCircle     = sel[1]                                                   # second object
    
    pointsDirection  = []
    
    pointsDirection = lineSelected.discretize(Number=500)                   # discretize the path line first selection
    
    v=pointsDirection[0].sub(pointsDirection[1])                            # avec vecteurs 1 et 2 (direction debut ligne)
    r=App.Rotation(App.Vector(0,0,1),v)
    
    pl=FreeCAD.Placement()                                                  # placement object
    pl.Rotation.Q = r.Q
    pl.Base = pointsDirection[0]
    myCircle.Placement = pl
    
    del pointsDirection[:]
    FreeCAD.ActiveDocument.recompute()
except Exception:
    print( "Select twoo objects 1:The path 2:The objet to align" )

Options

Principe :

la ligne est coupée en x points avec la fonction "discretize()" (dans la macro nombre de coupures Number = 500 de 0 à 499 nombre que vous pouvez modifier, équivaut à la précision)

pointsDirection = lineSelected.Shape.discretize(Number=500)             # discretize the path line first selection

la perpendicularité est calculée entre 2 points, modifiez :

1:

v=pointsDirection[0].sub(pointsDirection[1])          # perpendicular of first > second point

Macro Perpendicular To Wire 01.png

2:

v=pointsDirection[-1].sub(pointsDirection[-2])       # perpendicular of last > before last point
pl.Base = pointsDirection[-1]                        # position base last point

Macro Perpendicular To Wire 02.png

3:

v=pointsDirection[100].sub(pointsDirection[101])   # perpendicular of point 100 > point 101
pl.Base = pointsDirection[100]                     # position base point 100

Macro Perpendicular To Wire 03.png

4:

v=pointsDirection[0].sub(pointsDirection[-1])         # perpendicular of first point > last point
pl.Base = pointsDirection[0]                          # position base first point

Macro Perpendicular To Wire 04.png

Exemples



Macro Perpendicular To Wire 05.gif


Macro Perpendicular To Wire.gif

autres paramètres pour la fonction discretize()

#http://forum.freecadweb.org/viewtopic.php?f=12&t=16336#p129468
#Discretizes the edge and returns a list of points.
#The function accepts keywords as argument:
#discretize(Number=n) => gives a list of 'n' equidistant points
#discretize(QuasiNumber=n) => gives a list of 'n' quasi equidistant points (is faster than the method above)
#discretize(Distance=d) => gives a list of equidistant points with distance 'd'
#discretize(Deflection=d) => gives a list of points with a maximum deflection 'd' to the edge
#discretize(QuasiDeflection=d) => gives a list of points with a maximum deflection 'd' to the edge (faster)
#discretize(Angular=a,Curvature=c,[Minimum=m]) => gives a list of points with an angular deflection of 'a'
#and a curvature deflection of 'c'. Optionally a minimum number of points
#can be set which by default is set to 2.

La discussion sur le forum [Spiralbohrer]

Version

Ver 00.02 2019-04-06 : Python 3